#include <mpl.h>          /* include files */
#include <stdio.h>
#include <sys/time.h>

double when(){           /* time function to record current time*/
 struct timeval tp;
 struct timezone tzp;
 gettimeofday(&tp,&tzp);
 return ((double) tp.tv_sec + (double) tp.tv_usec*1e-6);
}
/*****************************************--*/
/* Calculations of local sums on each processors */
/*****************************************--*/
sum_local(int n,plural double * plural sum){
 plural int i,stop;
 int pnt;
 double n2,fourn;

 pnt= (int) (n/ nproc); 	/* Distributing n calculation to */
 fourn=4.0*n;			/* processes, calculations of formul */
 n2= (double)n* (double)n;	/* variables */

 *sum=0;			/* initiliaze local sums to 0*/
 for ( i=iproc*pnt+1,stop=i+pnt; i <stop;i++)  /* calculate n/p summation*/
       	*sum+= fourn/( n2+(i+0.5)*(i+0.5));	/* on each processor*/
 if ( iproc < (n-pnt*nproc) ){	/* the case: n is not integer multiple of p*/
	i=iproc + pnt*nproc;
	*sum+= fourn/( n2+(i+0.5)*(i+0.5));
 }
 return;
}
/*****************************************--*/
/* Collection of local sums to processor #0*/
/*****************************************--*/
double reduction(plural double * plural sum){
 int i;

 for (i=1; i< nxproc; i*=2)    /*rows collection*/
      *sum += xnetE[i].*sum;
 for (i=1; i< nyproc; i*=2)    /*columns reduction*/
      *sum += xnetS[i].*sum;

 return proc[0].*sum;
}
/*****************************************--*/
main(){
 int n;				/* variable definitions */
 plural double sum;
 double time;
 double pi;

 printf("Enter n in the summation formula :");  /* get input n */
 scanf("%d/n", &n);

 time = when();			/* record starting time*/	
 sum_local(n,&sum);		/* do local sums */
 pi=reduction(&sum);		/*reduce results to processor #0*/
 time = when()-time;		/*calculate execution time*/
 				/* print result */
 printf ("PI number is approximately calculated as %1.10lf in time %1.10lf. \n",pi,time);
}


