#include <stdio.h>
#include <stdio.h>
#include <fcntl.h>

integer **A;                            /* matrices*/
integer **B;
integer **C;
integer r,c;         /*local rows & columns*/
integer p,q;         /*mesh size*/  
integer num_of_p;


int btog(int binary)
{
    return(binary ^ (binary >> 1) );
}

int gtob(int gray)
{
    int binary = gray;
    
    while (( gray = ( gray >> 1 )) != 0)
	binary ^= gray;
    return(binary);
}

int X(int gray)
{
    return ( gtob ( gray / c));
}
int Y(int gray)
{
    return ( gtob(gray % c));
}

int Hid(int x,int y)
{
    return ( btog(x)*c + btog(y) );
}

integer get_matrix(void)
{
    integer * p;
    integer **q;
    
    p= calloc(r*c,sizeof(integer));
    if (!p)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    q=(integer**)calloc(r,sizeof(integer *));
    if (!q)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    for (i=0;i<r;i++)
	q[i]=p+i*c;
    return q;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
create a matrices distributed over processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
create_matrices()
{
    integer me;
    integer lastx,lasty;
    lastx=q;
    lasty=p;
    me=mynode();
    A=get_matrix();
    B=get_matrix();
    C=get_matrix();
    x=X(iam)+1;
    y=Y(iam)+1;    
    for(i=0; i< r;i++)
	for(j=0;j<c;j++)
	    if ( (x==lastx) && (i > r- r_dummy))
		A[i][j]=0;
	    else if ( (y==lasty) && (j>c-c_dummy)
		A[i][j]=0;      
	    else A[i][j]=2;
    for(i=0; i< r;i++)
	for(j=0;j<c;j++)
	    if ( (x==lastx) && (i > r- r_dummy))
		B[i][j]=0;
	    else if ( (y==lasty) && (j>c-c_dummy)
		B[i][j]=0;      
	    else B[i][j]=i;	    
    print_matrix(A);
    print_matrix(B);
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
print matrices to the screen
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
print_matrix(integer **m)
{
    integer iam;
    
    iam=mynode();
    if (!iam) printf("\n");
    x=X(iam);
    y=Y(iam);
    gsync();
    for (k=0;k< p;k++)
	{
	    if ( k==x)
		for(l=0;l<q;l++)
		    {
			if ( l==y)
			    {
				for(i=0;i<n/p;i++)
				    {
					for(j=0;j<n/q;j++)
					    if ( (x==p) && (i > r- r_dummy))
						;
					    else if ( (y==q) && (j>c-c_dummy))
						;
					    else printf("%d ",m[i][j]);
					if (y==q) printf("\n");
				    }
				
			    }
			getsync();
			
		       }
	    getsync();
	    
	}
    
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
read matrix size and number of processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
read_p_n()
{
    integer me;
    char  instring[40];
    integer num_of_p;
    
    me=mynode();
    if (me==0)
	{
	    printf("Enter matrix size  n:");
	    gets(instring);
	    sscanf(instring,"%d",&n);
	    csend(1,(char *)&n, sizeof(n), -1, 0);
	    printf("Enter number of procesors:");
	    gets(instring);
	    sscanf(instring,"%d",&num_of_p);
	    csend(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0);
	}
    else
	{
	    crecv(1,(char *)&n, sizeof(n), -1, 0);
	    crecv(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0);
	}
    for ( i=0,k=0;num_of_p !=1;i++,k++)
	num_of_p/2;
    for (i=0,q=1;i<k/2;i++)
	q*=2;
    p=q;
    if ( (k % 2)== 1)
	p=q*2;

/****check***/
    if (!me) printf(" %d %d \n",p,q);
    
}
mult()
{
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
main
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
main()
{
    read_p_n();
    create_matrices();
    mult();
    print_matrix(C);
}



