#include <stdio.h>
#include <sys/types.h>
#include <math.h>
#include <cm/cmmd.h>
#include "const.h"


void CMPE_node_program()
{ 
  int     i,j,k,size,nproc;
  int     Arows,Acols,Brows,Bcols;
  float   **mtxB, **create_matrix();
  float   *row_A_arr, *row_C_arr;
  int     Bcols_per_proc, Arows_per_proc;
  int     Ccols_per_proc, elem_C_size;

  CMMD_sync_with_nodes();
  CMMD_sync_with_host();

  CMMD_receive_bc_from_host(&Arows, sizeof(int));
  CMMD_receive_bc_from_host(&Acols, sizeof(int));
  CMMD_receive_bc_from_host(&Brows, sizeof(int));
  CMMD_receive_bc_from_host(&Bcols, sizeof(int));

  nproc = CMMD_partition_size();

  Bcols_per_proc = Ccols_per_proc = Bcols/nproc;
  mtxB = create_matrix(Brows,Bcols_per_proc);
  receive_columns_uniformly(Brows,Bcols_per_proc,mtxB);
  row_A_arr = (float *) calloc(Acols,sizeof(float));
  row_C_arr = (float *) calloc(Ccols_per_proc, sizeof(float));
  
  elem_C_size = Ccols_per_proc*sizeof(float);
  for (i=0; i<Arows; i++) {
    CMMD_receive_bc_from_host(row_A_arr, (Acols*sizeof(float)));
    do_multiplication(row_A_arr,Brows,Bcols_per_proc,mtxB,row_C_arr);
    CMMD_concat_elements_to_host(row_C_arr, elem_C_size);
  }
}


do_multiplication(row_A_arr,Brows,Bcols_per_proc,mtxB,row_C_arr)
int Brows,Bcols_per_proc;
float *row_A_arr, **mtxB, *row_C_arr;
{
   int hostaddr,i,j,k,size;

   for (j=0; j<Bcols_per_proc; j++) {
         row_C_arr[j] = 0.0;
         for (k=0; k<Brows; k++)
            row_C_arr[j] = row_C_arr[j] + row_A_arr[k]*mtxB[k][j];
   }
}




receive_columns_uniformly(nrows,ncols,mtx)
int nrows,ncols;
float **mtx;
{
      int i,length;
      
      length = ncols*sizeof(float);
      for (i=0; i<nrows; i++) {
         CMMD_receive_element_from_host(mtx[i],length);
      }
}
