#include <stdio.h>
#include <cube.h>
#include <fcntl.h>
#include <stdlib.h>
int **A;                            /* matrices*/
int **B;
int **C;
int r,c;         /*local rows & columns*/
int p,q;         /*mesh size*/  
int n;
int num_of_p;
int i,j,k;
int me;
int x,y,lastx,lasty;
int dummy;
int *Nbuffer;
int *Wbuffer;
int print_matrix(int **,char *);
unsigned long start,finish,mtime;
double speedup;
/***************************************************
******************program***************************
***************************************************/
int btog(int binary)
{
    return(binary ^ (binary >> 1) );
}

int gtob(int gray)
{
    int binary = gray;

    while (( gray = ( gray >> 1 )) != 0)
	binary ^= gray;
    return(binary);
}

int X(int gray)
{
    return ( gtob ( gray / q));
}
int Y(int gray)
{
    return ( gtob(gray % q));
}

int Hid(int x,int y)
{
    return ( btog(x)*q+btog(y) );
}
int * get_buffer(int s)
{
    int * p;
    
    p= (int *) calloc(s,sizeof(int));
    if (!p)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    return p;
}
int ** get_matrix(r,c)
    int r;
    int c;
{
    int * p;
    int **q;
    
    p= (int *) calloc(r*c,sizeof(int));
    if (!p)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    q=(int**)calloc(r,sizeof(int *));
    if (!q)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    for (i=0;i<r;i++)
	q[i]=p+i*c;
    return q;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
create a matrices distributed over processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
create_matrices()
{
    A=get_matrix(r,c);
    B=get_matrix(r,c);
    C=get_matrix(r,c);
    x=X(me);
    y=Y(me);    
    for(i=0; i< r;i++)
	for(j=0;j<c;j++)
	    if ( (y==lasty) && (j >= (c- dummy)))
		A[i][j]=0;
	    else if ( (x==lastx) && (i>=r-dummy))
		A[i][j]=0;      
	    else A[i][j]=1;
    for(i=0; i< r;i++)
	for(j=0;j<c;j++)
	    if ( (y==lasty) && (j >= (c- dummy)))
		B[i][j]=0;
	    else if ( (x==lastx) && (i>=(r-dummy)))
		B[i][j]=0;      
	    else B[i][j]= (x*r+i)*(n-dummy)+y*c+j;	  
    /*initiliaze*/
    for ( i=0; i < r;i++)
	for(j=0;j<c;j++)
	    C[i][j]=0;
    print_matrix(A,"A"); 
    print_matrix(B,"B");
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
read matrix size and number of processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
read_p_n()
{
    char  instring[40];
    num_of_p=4;
    n=10;
    if (me==0)
	{
	    printf("\nNumber of available processors %d",numnodes());
	    printf("\nEnter matrix size  n:\n");
	    gets(instring);
	    sscanf(instring,"%d",&n);
	    csend(1,(char *)&n, sizeof(n), -1, 0);
	    printf("Enter number of procesors:\n");
	    gets(instring);
	    sscanf(instring,"%d",&num_of_p);
	    csend(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0);
	}
    else
	{
	    crecv(1,(char *)&n, sizeof(n), -1, 0);
	    crecv(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0); 
	}
    if ( p > numnodes() )
	{
	    fprintf(stderr,"Not enough cube...!");
	    exit(1);
	}
    
/****check***/

/****check***/    
    for ( i=0,k=0;num_of_p !=1;i++,k++)
	num_of_p/=2;
    for (i=0,q=1;i<k/2;i++)
	q*=2;
    p=q;
    if ( (k % 2)== 1)
	p=q*2;
/****check***/
    if (!me) printf(" \nMesh is p %d x q %d \n",p,q);
/***********/
    if ( (n%p)) {
	dummy= ((n/p)+1)*p-n;
	n=n+dummy;
    }
    r=n/p;
    c=n/q;
    if (!me) printf(" \nLocal matrix sizes; row %d x column %d \n",r,c);
    lastx=p-1;
    lasty=q-1;
    if ( q==1) Wbuffer=get_buffer(r);
    if ( p==1) Nbuffer=get_buffer(c);
    
	
}
West(int x,int y)
{

    if ( y==0){ 
	if ( q > 1 )
	    csend( (i*r+x)*n+(j*c+y),(char *)&A[x][y], sizeof(int), Hid( i,(j-1+q)%q ), 0); 
	else Wbuffer[x]=A[x][y];
    }
    else A[x][(y-1+c)%c]=A[x][y];

    if ( y==(c-1)) {
	if ( q > 1)
	    crecv( (i*r+x)*n+((j*c+y+1)%n) ,(char *)&A[x][y], sizeof(int)); 
	else A[x][y]=Wbuffer[x];	
    }
}
North(int x,int y)
{

    if ( x==0) {
	if ( p > 1)
	    csend( (i*r+x)*n+(j*c+y) ,(char *)&B[x][y], sizeof(int), Hid( (i-1+p)%p,j) , 0); 
	else Nbuffer[y]=B[x][y];
    }
    else B[(x-1+r)%r][y]=B[x][y];

    if ( x==(r-1)) {
	if ( p>1)
	    crecv(  ( (i*r+x+1)%n)*n+(j*c+y),(char *)&B[x][y], sizeof(int));
	else B[x][y]=Nbuffer[y];
    }
}

unsigned long mult()
{
    int basex,basey;
    i=X(me);
    j=Y(me);
    basex= i*r;
    basey= j*c;

    start=mclock();
        /*precondition*/
    for (k=0;k<n;k++)
	for (x=0;x<r;x++)
	    for(y=0;y<c;y++)
		{ 
		    if ( (x+basex)>k) 
			West(x,y);
		    if  ((y+basey)>k)
			North(x,y);
		}

    /*multiplication*/

    for (k=0;k<n;k++)
	for (x=0;x<r;x++)
	    for(y=0;y<c;y++)
		{
		    C[x][y]+=A[x][y]*B[x][y];
		    West(x,y);
		    North(x,y);
		}
    finish=mclock();
    return finish-start;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
main
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
main()
{
    me=mynode();
    read_p_n(); 
    create_matrices();
    gsync();
    if ( me < p*q ) 
	mtime=mult();
    
    print_matrix(C,"C");
    printf("Multiplication time is %ld miliseconds.\n",mtime);
    if (!me)
	{
	    speedup=(double) mtime;
	    mtime=sequential();
	    speedup/= (double) mtime;
	    printf("Multiplication time is %ld miliseconds.\n",mtime);
	    printf("SpeedUp is %lf \n",speedup);
	    
	}
    
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
print matrices to the screen
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int print_matrix(int **m, char * message)
{
    if (!me) printf("\n");
    x=X(me); 
    y=Y(me); 
    if (!me) printf("Matrix  %s :\n",message); 
    gsync(); 
    for (i=0;i< (n-dummy);i++) 
 	{ 
 	    for(j=0;j<(n-dummy);j++) 
 		{ 
 		    if ( ((i/r)==x) && ((j/c)==y) ) 
 			{ 
 			    fprintf(stderr,"%4d",m[i%r][j%c]); 
			    if ( !((j+1)%c) || (j==n-dummy-1) ) 
				fflush(stderr);
			}
		    gsync();
		}
	    if (me ==0) {fprintf(stderr,".\n"); fflush(stderr);
	    }
	    gsync();
	}
    gsync();
}


int sequential()
{
    n-=dummy;
    A=get_matrix(n,n);
    B=get_matrix(n,n);
    C=get_matrix(n,n);

    for(i=0; i< n;i++)        /*create same matrices on one node*/
	for(j=0;j<n;j++)   
	    A[i][j]=1;
    for(i=0; i< n;i++)
	for(j=0;j<n;j++)
	    B[i][j]=i*n+j;      
    for ( i=0; i < n;i++)
	for(j=0;j<n;j++)
	    C[i][j]=0;
    start=mclock();          /*sequential start*/
    for ( i=0; i < n;i++)
	for(j=0;j<n;j++)
	    for (k=0;k<n;k++)
	    C[i][j]+=A[i][k]*B[k][j];
    finish=mclock();          /* print result */
    for ( i=0; i < n;i++)
	{
	    for(j=0;j<n;j++)
		printf("%4d", C[i][j]);
	    printf("\n");
	}
    return (finish-start);
}

