#include <stdio.h>
#include <cube.h>
#include <fcntl.h>
#include <stdlib.h>
int **A;                            /* matrices*/
int **B;
int **C;
int r,c;         /*local rows & columns*/
int p,q;         /*mesh size*/  
int n;
int num_of_p;
int i,j,k;
int me;
int x,y,lastx,lasty;
int dummy;
int print_matrix(int **);

int btog(int binary)
{
    return(binary ^ (binary >> 1) );
}

int gtob(int gray)
{
    int binary = gray;

    while (( gray = ( gray >> 1 )) != 0)
	binary ^= gray;
    return(binary);
}

int X(int gray)
{
    return ( gtob ( gray / q));
}
int Y(int gray)
{
    return ( gtob(gray % q));
}

int Hid(int x,int y)
{
    return ( btog(x)*q + btog(y) );
}

int ** get_matrix(void)
{
    int * p;
    int **q;
    
    p= (int *) calloc(r*c,sizeof(int));
    if (!p)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    q=(int**)calloc(r,sizeof(int *));
    if (!q)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    for (i=0;i<r;i++)
	q[i]=p+i*c;
    return q;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
create a matrices distributed over processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
create_matrices()
{
    A=get_matrix();
    B=get_matrix();
    C=get_matrix();
    x=X(me);
    y=Y(me);    
    for(i=0; i< r;i++)
	for(j=0;j<c;j++)
	    if ( (y==lasty) && (j >= (c- dummy)))
		A[i][j]=0;
	    else if ( (x==lastx) && (i>=r-dummy))
		A[i][j]=0;      
	    else A[i][j]=1;
    for(i=0; i< r;i++)
	for(j=0;j<c;j++)
	    if ( (y==lasty) && (j >= (c- dummy)))
		B[i][j]=0;
	    else if ( (x==lastx) && (i>=(r-dummy)))
		B[i][j]=0;      
	    else B[i][j]=i*r;	  
    /*initiliaze*/
    for ( i=0; i < r;i++)
	for(j=0;j<c;j++)
	    C[i][j]=0;
    print_matrix(A); 
    print_matrix(B);
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
print matrices to the screen
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int pprint_matrix(int **m)
{
    int l,iam;
    
    iam=mynode();
    if (!iam) printf("\n");
    x=X(iam);
    y=Y(iam);
    printf(" kkkkk %d %d\n",y,x);
    
    gsync();
    for (k=0;k< p;k++)
	{

		for(l=0;l<q;l++)
		    {
			if ( (l==x)&&( k==y))
			    {
				for(i=0;i<r;i++)
				    {
					for(j=0;j<c;j++)/*
					    if ( (y==lasty) && (i > r- dummy))
						;
					    else if ( (x==lasty) && (j>c-dummy))
						;
					    else */printf("%d ",m[i][j]);
					if (x==lasty) printf("\n");
				    }
				
			    }
			gsync();
			
		       }
	}
    gsync();
    
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
read matrix size and number of processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
read_p_n()
{
    char  instring[40];
    num_of_p=4;
    n=10;
    if (me==0)
	{
	    printf("\nNumber of available processors %d\n",numnodes());
	    printf("\nEnter matrix size  n:\n");
	    gets(instring);
	    sscanf(instring,"%d",&n);
	    csend(1,(char *)&n, sizeof(n), -1, 0);
	    printf("Enter number of procesors:\n");
	    gets(instring);
	    sscanf(instring,"%d",&num_of_p);
	    csend(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0);
	}
    else
	{
	    crecv(1,(char *)&n, sizeof(n), -1, 0);
	    crecv(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0); 
	}
    if ( p > numnodes() )
	{
	    fprintf(stderr,"Not enough cube...!");
	    exit(1);
	}
    
/****check***/

/****check***/    
    for ( i=0,k=0;num_of_p !=1;i++,k++)
	num_of_p/=2;
    for (i=0,q=1;i<k/2;i++)
	q*=2;
    p=q;
    if ( (k % 2)== 1)
	p=q*2;
/****check***/
    if (!me) printf(" \np %d q %d \n",p,q);
/***********/
    if ( (n%p)) {
	dummy= ((n/p)+1)*p-n;
	n=n+dummy;
    }
    r=n/p;
    c=n/q;
    if (!me) printf(" \nr %d c %d \n",r,c);
    lastx=p-1;
    lasty=q-1;
}
West(int x,int y)
{
    if ( (y%c)==0) 
	    csend(x*n+y,(char *)&A[x%r][y%c], sizeof(int), Hid( x/r,(((y-1+n)%n)/c) ) , 0); 
    else A[x%r][(y-1+c)%c]=A[x%r][y%c];
    if ( (y%c)==(c-1)) 
	crecv(x*n+((y+1)%n),(char *)&A[x%r][y%c], sizeof(int)); 
}
North(int x,int y)
{
    if ( (x%r)==0) 
	    csend(x*n+y,(char *)&B[x%r][y%c], sizeof(int), Hid( (((x-1+n)%n)/r), y/c ) , 0); 
    else B[(x-1+r)%r][y]=B[x%r][y%c];
    if ( (x%r)==(r-1)) 
		crecv( ((x+1)%n)*n+y,(char *)&B[x%r][(y)%c], sizeof(int));
}


mult()
{
    i=X(me);
    j=Y(me);
    /*precondition*/
    for (k=0;k<n;k++)
	{   
	    for (x=0;x<n;x++)
		for(y=0;y<n;y++)
		    {
			if (((x / r)==i) && ((y/c)==j))
			    {
				if ( x>k) 
				    West(x,y);
				if  (y>k)
				     North(x,y);
			    }
		    }
	}

    /*multiplication*/
    
    for (k=0;k<n;k++)
	{    
	    for (x=0;x<n;x++)
		for(y=0;y<n;y++)
		    {
			if (((x / r)==i) && ((y/c)==j))
			    {
				C[x%r][y%c]+=A[x%r][y%c]*B[x%r][y%c];
				West(x,y);
				North(x,y);
			    }
			
		    }
	}
    
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
main
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
main()
{
    me=mynode();
    read_p_n();
    create_matrices();
    mult();
    print_matrix(C);
      
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
print matrices to the screen
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int print_matrix(int **m)
{
    if (!me) printf("\n");
    x=X(me); 
    y=Y(me); 
    if (!me) printf(" rdummy  %d n is %d\n",dummy,n); 

    gsync(); 
    for (i=0;i< (n-dummy);i++) 
 	{ 
 	    for(j=0;j<(n-dummy);j++) 
 		{ 
 		    if ( ((i/r)==x) && ((j/c)==y) ) 
 			{ 
 			    fprintf(stderr,"%3d",m[i%r][j%c]); 
			    if ( !((j+1)%c) || (j==n-dummy-1) ) 
				fflush(stderr);
			}
		    gsync();
		}
	    if (me ==0) {fprintf(stderr,".\n"); fflush(stderr);
	    }
	    gsync();
	}
    gsync();
}




