#include <stdio.h>
#include <cube.h>
#include <fcntl.h>
#include <stdlib.h>
int **A1;
int **A2;                            /* matrices*/
int **B1;
int **B2;
int **C1;

int **C2;
int I=1;
int prn;

int r,c;         /*local rows & columns*/
int p,q;         /*mesh size*/  
int n;
int num_of_p;
int i,j,k;
int me;
int x,y,lastx,lasty;
int dummy=0;
int *Nbuffer,*Nsend,*Nget;
int *Wbuffer,*Wsend,*Wget;
int print_matrix(int **,int **, char *);
unsigned long start,finish,mtime;
double speedup;
/***************************************************
******************program***************************
***************************************************/
int btog(int binary)
{
    return(binary ^ (binary >> 1) );
}

int gtob(int gray)
{
    int binary = gray;

    while (( gray = ( gray >> 1 )) != 0)
	binary ^= gray;
    return(binary);
}

int X(int gray)
{
    return ( gtob ( gray / q));
}
int Y(int gray)
{
    return ( gtob(gray % q));
}

int Hid(int x,int y)
{
    return ( btog(x)*q+btog(y) );
}
int * get_buffer(int s)
{
    int * p;
    
    p= (int *) calloc(s,sizeof(int));
    if (!p)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    return p;
}
int ** get_matrix(r,c)
    int r;
    int c;
{
    int * p;
    int **q;
    
    p= (int *) calloc(r*c,sizeof(int));
    if (!p)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    q=(int**)calloc(r,sizeof(int *));
    if (!q)
	{
	    printf("Allocation-error: Program aborted..!\n");
	    exit(1);
	}
    for (i=0;i<r;i++)
	q[i]=p+i*c;
    return q;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
create a matrices distributed over processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
create_matrices()
{
    int base;
    
    base=c/2;
    
    if (I)
	{
	    A2=A1=get_matrix(r,c);
	    B2=B1=get_matrix(r,c);
	    C2=C1=get_matrix(r,c);
	}
    else 
	{
	   A2=get_matrix(r,c/2);
	   B2=get_matrix(r,c/2);
	   C2=get_matrix(r,c/2);  
	   A1=get_matrix(r,c/2);
	   B1=get_matrix(r,c/2);
	   C1=get_matrix(r,c/2);  
	}
    
    x=X(me);
    y=Y(me);    

    for(i=0; i< r;i++)
	{
	    for(j=0;j<r;j++)
		if ( (y==lasty) && (j >= (c- dummy)))
		    A1[i][j]=0;
		else if ( (x==lastx) && (i>=r-dummy))
		    A1[i][j]=0;      
		else  A1[i][j]=1;
	    if (!I)
		for (j=0; j<r;j++)
		    if ( (y==lasty) && (j+base >= (c- dummy)))
			A2[i][j]=0;
		    else if ( (x==lastx) && (i>=r-dummy))
			A2[i][j]=0;      
		    else  A2[i][j]=1;
	}
    for(i=0; i< r;i++)
	{
	    for(j=0;j<r;j++)
		B1[i][j]= (x*r+i)*(n-dummy)+y*c+j;	  
	    if (!I)
		for (j=0; j<r;j++)
		    B2[i][j]= (x*r+i)*(n-dummy)+y*c+j+base;	
	}
    
    /*initiliaze*/
    for ( i=0; i < r;i++)
	for(j=0;j<r;j++)
	    C1[i][j]=0;
    if (!I)
    for ( i=0; i < r;i++)
	for(j=0;j<r;j++)
	    C2[i][j]=0;
    print_matrix(A1,A2,"A"); 
    print_matrix(B1,B2,"B");
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
read matrix size and number of processors
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
read_p_n()
{
    char  instring[40];
    num_of_p=4;
    n=10;
    if (me==0)
	{
	    printf("\nNumber of available processors %d",numnodes());
	    printf("\nEnter matrix size  n:\n");
	    gets(instring);
	    sscanf(instring,"%d",&n);
	    csend(1,(char *)&n, sizeof(n), -1, 0);
	    printf("Enter number of procesors:\n");
	    gets(instring);
	    sscanf(instring,"%d",&num_of_p);
	    csend(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0);
	     printf("Print matrices (0/1):\n");
	    gets(instring);
	    sscanf(instring,"%d",&prn);
	    csend(3,(char *)&prn, sizeof(prn), -1, 0);
	}
    else
	{
	    crecv(1,(char *)&n, sizeof(n), -1, 0);
	    crecv(2,(char *)&num_of_p, sizeof(num_of_p), -1, 0); 
	     crecv(3,(char *)&prn, sizeof(n), -1, 0);
	}
    if ( p > numnodes() )
	{
	    fprintf(stderr,"Not enough cube...!");
	    exit(1);
	}
    
/****check***/

/****check***/    
    for ( i=0,k=0;num_of_p !=1;i++,k++)
	num_of_p/=2;
    for (i=0,q=1;i<k/2;i++)
	q*=2;
    p=q;
    if ( (k % 2)== 1)
	{
	    p=q*2;
	    I=0;
	}
    
/****check***/
    if (!me) printf(" \nMesh is p %d x q %d \n",p,q);
/***********/
    if ( (n%p)) {
	dummy= ((n/p)+1)*p-n;
	n=n+dummy;
    }
    r=n/p;
    c=n/q;
    if (!me) printf(" \nLocal matrix sizes; row %d x column %d \n",r,c);
    lastx=p-1;
    lasty=q-1;
    if ( q==1) Wbuffer=get_buffer(r);
    if ( p==1) Nbuffer=get_buffer(c);
    Wsend=get_buffer(r);
    Wget=get_buffer(r);
    Nsend=get_buffer(c);
    Nget=get_buffer(c);
	
}

local ()
{ int d,f,g;


 for ( d=0; d < r;d++)
     for(f=0;f<r;f++)
     {
	 for (g=0;g<r;g++)
	     C1[d][f]+=A1[d][g]*B1[g][f];
     }
if ( !I)
 for ( d=0; d < r;d++)
     for(f=0;f<r;f++)
     {
	 for (g=0;g<r;g++)
	     C2[d][f]+=A2[d][g]*B2[g][f];
     }

}

unsigned long mult()
{
    int typebase,size,tbase2;
    int **T;
    
    i=X(me);
    j=Y(me);
    size=sizeof(int)*(r*r);
    
    typebase=n*(k+1);
    tbase2=2*n*(k+1);
    
    start=mclock();
    /*precondition*/
    for (k=0;k<p;k++)
	{  
	    if ( (i)>k) 
		if ( q==1)
			{
			    T=A1;
			    A1=A2;
			    A2=T;  
			}			
		    else 
			{
			    csend( Hid(i,(j-1+q)%q) +typebase ,(char*)A1[0],size , Hid( i,(j-1+q)%q ), 0); 
			    T=A1;
			    A1=A2;
			    A2=T;
			    crecv( typebase+me,(char*)A2[0],size);
			}
	    if (I)
		{
		    if  (j>k)
			if ( p>1)
			    {
				csend(Hid( (i-1+p)%p,j) ,(char*)B1[0],size,Hid( (i-1+p)%p,j) , 0);
				crecv( me,(char *)B1[0], size); 
			    }
		}
	    else
		{
		    if  ((j*2)>k)
			if ( p>1)
			    {
				csend(Hid( (i-1+p)%p,j) ,(char*)B1[0],size,Hid( (i-1+p)%p,j) , 0);
				crecv( me,(char *)B1[0], size); 
			    }
		    if ( (j*2+1)>k ) 
			if ( p>1)
			    {
				csend(Hid( (i-1+p)%p,j)+1 ,(char*)B2[0],size,Hid( (i-1+p)%p,j) , 0);
				crecv( me+1,(char *)B2[0], size);
			    }
		}
	}
    
    /*multiplication*/
    
    for (k=0;k<p;k++)
	{  
	    local();
	    
	    if ( q==1)
		{
		    T=A1;
		    A1=A2;
		    A2=T;  
		}			
	    else 
		{
		    csend( Hid(i,(j-1+q)%q) +tbase2 ,(char*)A1[0],size , Hid( i,(j-1+q)%q ), 0); 
		    T=A1;
		    A1=A2;
		    A2=T;
		    crecv( tbase2+me,(char*)A2[0],size);
		}
	    if (I)
		{
		    if ( p>1)
			{
			    csend(Hid( (i-1+p)%p,j) ,(char*)B1[0],size,Hid( (i-1+p)%p,j) , 0);
			    crecv( me,(char *)B1[0], size); 
			}
		}
	    else
		{
		    if ( p>1)
			{
			    csend(Hid( (i-1+p)%p,j) ,(char*)B1[0],size,Hid( (i-1+p)%p,j) , 0);
			    crecv( me,(char *)B1[0], size); 
			}
		    if ( p>1)
			{
			    csend(Hid( (i-1+p)%p,j)+1 ,(char*)B2[0],size,Hid( (i-1+p)%p,j) , 0);
			    crecv( me+1,(char *)B2[0], size);
			}
		}
	}
    finish=mclock();
    return finish-start;
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
main
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
main()
{
    me=mynode();
    read_p_n(); 
    create_matrices();
    gsync();
    if ( me < p*q ) 
	mtime=mult();
    
    print_matrix(C1,C2,"C");
    if (!me) printf("Multiplication time is %ld miliseconds.\n",mtime);
    if (!me)
	{
	    speedup=(double) mtime;
	    mtime=sequential();
	    speedup= (double) mtime /speedup;
	    printf("Sequential multiplication time is %ld miliseconds.\n",mtime);
	    printf("SpeedUp is %lf \n",speedup);
	    
	}
    
}
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
print matrices to the screen
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
int print_matrix(int **m1,int **m2, char * message)
{
    int **m;
    
/*************************/
    if (!prn)    return 0; 
/*************************/    
    if (!me) printf("\n");
    x=X(me); 
    y=Y(me); 
    if (!me) printf("Matrix  %s :\n",message); 
    gsync(); 
    for (i=0;i< (n-dummy);i++) 
 	{ 
 	    for(j=0;j<(n-dummy);j++) 
 		{ 
 		    if ( ((i/r)==x) && ((j/c)==y) ) 
 			{ 
			    if (I)
				fprintf(stderr,"%4d",m1[i%r][j%(c)]); 
			    else 
				{
				    if ( (j%c) >= (c/2) ) m=m2;
				    else m=m1;
				    fprintf(stderr,"%4d",m[i%r][j%(c/2)]); 
				}
			    
			    if ( !((j+1)%c) || (j==n-dummy-1) ) 
				fflush(stderr);
			}
		    gsync();
		}
	    if (me ==0) {fprintf(stderr,".\n"); fflush(stderr);
	    }
	    gsync();
	}
    gsync();
}


int sequential()
{
    int **A;
    int **B;
    int **C;
    
    n-=dummy;
    A=get_matrix(n,n);
    B=get_matrix(n,n);
    C=get_matrix(n,n);

    for(i=0; i< n;i++)        /*create same matrices on one node*/
	for(j=0;j<n;j++)   
	    A[i][j]=1;
    for(i=0; i< n;i++)
	for(j=0;j<n;j++)
	    B[i][j]=i*n+j;      
    for ( i=0; i < n;i++)
	for(j=0;j<n;j++)
	    C[i][j]=0;
    start=mclock();          /*sequential start*/
    for ( i=0; i < n;i++)
	for(j=0;j<n;j++)
	    {
		for (k=0;k<n;k++)
		    C[i][j]+=A[i][k]*B[k][j];
	    }
    
    finish=mclock();          /* print result */
if (prn)
    for ( i=0; i < n;i++)
	{
	    for(j=0;j<n;j++)
		printf("%4d", C[i][j]);
	    printf("\n");
	}
	
    return (finish-start);
}






